unit UnitFormEntityBase;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UnitCommonTypes, ToolWin, ComCtrls, ActnList, Menus, ImgList, UnitFormBase,
  UnitObjectEntityBase;

type
  TFormEntityBase = class(TFormBase)
    StatusBarEntity: TStatusBar;
    ToolBarEntityAbstract: TToolBar;
    ActionListEntity: TActionList;
    ActionSave: TAction;
    PopupMenuEntity: TPopupMenu;
    Save1: TMenuItem;
    ToolButtonSaveAbstract: TToolButton;
    ActionShowHints: TAction;
    N1: TMenuItem;
    ShowHints1: TMenuItem;
    ToolButtonEntityAbstractSeparator: TToolButton;
    procedure ActionSaveExecute(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ActionSaveUpdate(Sender: TObject);
    procedure ActionShowHintsExecute(Sender: TObject);
    procedure ActionShowHintsUpdate(Sender: TObject);
  private
  protected
  public
  end;

implementation

{$R *.DFM}

{ TFormEntityAbstract }

procedure TFormEntityBase.ActionSaveExecute(Sender: TObject);
begin
  inherited;
  Save;
end;

procedure TFormEntityBase.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  inherited;
  Action := caFree;
end;

procedure TFormEntityBase.ActionSaveUpdate(Sender: TObject);
var b: boolean;
begin
  inherited;
  b := BusinessObject.UpdatesPending;
  ActionSave.Enabled := b;
end;

procedure TFormEntityBase.ActionShowHintsExecute(Sender: TObject);
begin
  inherited;
  Self.ShowHint := not(Self.ShowHint);
end;

procedure TFormEntityBase.ActionShowHintsUpdate(Sender: TObject);
begin
  inherited;
  ActionShowHints.Checked := Self.ShowHint;
end;


end.
