unit UnitObjectResultSetOrders;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UnitObjectResultSetBase, Db, DBTables;

type
  TObjectResultSetOrders = class(TObjectResultSetBase)
    QuerySaleDate: TDateTimeField;
    QueryShipDate: TDateTimeField;
    QueryEmpNo: TIntegerField;
    QueryShipToContact: TStringField;
    QueryShipToAddr1: TStringField;
    QueryShipToAddr2: TStringField;
    QueryShipToCity: TStringField;
    QueryShipToState: TStringField;
    QueryShipToZip: TStringField;
    QueryShipToCountry: TStringField;
    QueryShipToPhone: TStringField;
    QueryShipVIA: TStringField;
    QueryPO: TStringField;
    QueryTerms: TStringField;
    QueryPaymentMethod: TStringField;
    QueryItemsTotal: TCurrencyField;
    QueryTaxRate: TFloatField;
    QueryFreight: TCurrencyField;
    QueryAmountPaid: TCurrencyField;
    QueryOrderNo: TFloatField;
    QueryCustNo: TFloatField;
  private
    { Private declarations }
  protected
    function GetSqlSelectClause: string; override;
    function GetSqlFromClause: string; override;
    function GetSelectedRecordKey: integer; override;
  public
  end;

var
  ObjectResultSetOrders: TObjectResultSetOrders;

implementation

{$R *.DFM}

{ TObjectResultSetOrders }

function TObjectResultSetOrders.GetSelectedRecordKey: integer;
begin
  Result := Query.FieldByName('OrderNo').AsInteger;
end;

function TObjectResultSetOrders.GetSqlFromClause: string;
begin
  Result := 'orders.db';
end;

function TObjectResultSetOrders.GetSqlSelectClause: string;
begin
  Result := '*';
end;

end.
