unit UnitFormMain;
{
After you've added a new list add an action to display the list. Do this by
adding an action to component ActionList. In the action's execute method
put a line of code like: "FormListOrders.ShowForm;" For this to work you need
to add FormListOrders as a TFormBase class method (function)
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ToolWin, ComCtrls, ActnList, ImgList, UnitFormBase;

type
  TFormMain = class(TFormBase)
    ActionList: TActionList;
    ToolBarMain: TToolBar;
    MainMenu: TMainMenu;
    File1: TMenuItem;
    Find1: TMenuItem;
    Exit1: TMenuItem;
    ActionTerminate: TAction;
    ActionSaveAll: TAction;
    SaveAll1: TMenuItem;
    N1: TMenuItem;
    ToolButton5: TToolButton;
    ActionFindOrders: TAction;
    Orders1: TMenuItem;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ActionFindCustomer: TAction;
    ToolButton3: TToolButton;
    Customer1: TMenuItem;
    procedure ActionTerminateExecute(Sender: TObject);
    procedure ActionSaveAllExecute(Sender: TObject);
    procedure ActionSaveAllUpdate(Sender: TObject);
    procedure ActionFindOrdersExecute(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ActionFindCustomerExecute(Sender: TObject);
  private
  public
  end;

var FormMain: TFormMain;

implementation

uses
  UnitFormListBase
, UnitObjectBase
, UnitFormListOrders
, UnitFormListCustomer
  ;

{$R *.DFM}

procedure TFormMain.ActionTerminateExecute(Sender: TObject);
begin
  inherited;
	Application.Terminate;
end;

procedure TFormMain.ActionSaveAllExecute(Sender: TObject);
begin
  inherited;
  TObjectBase.SaveAll;
end;

procedure TFormMain.ActionSaveAllUpdate(Sender: TObject);
begin
  inherited;
  ActionSaveAll.Enabled := TObjectBase.AnyUpdatesPending;
end;

procedure TFormMain.ActionFindOrdersExecute(Sender: TObject);
begin
  inherited;
  // Using new integer means we get a new list every time the user chooses "Find"
  TFormListOrders.FetchForm(NewInteger).ShowForm;
end;

procedure TFormMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  inherited;
  TFormBase.CloseAll;
  Application.ProcessMessages;
  CanClose := (TFormBase.FormCount = 0);
end;

procedure TFormMain.ActionFindCustomerExecute(Sender: TObject);
begin
  inherited;
  // Using new integer means we get a new list every time the user chooses "Find"
  TFormListCustomer.FetchForm(NewInteger).ShowForm;
end;

end.
