unit UnitObjectEntityOrders;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UnitObjectEntityBase, Db, DBTables;

type
  TObjectEntityOrders = class(TObjectEntityBase)
    QueryOrders: TQuery;
  private
  protected
    procedure InitializeObject; override;
  public
    function UpdatesPending: boolean; override;
    procedure Save; override;
    procedure Cancel; override;
  end;

var
  ObjectEntityOrders: TObjectEntityOrders;

implementation

{$R *.DFM}

{ TObjectEntityBaseOrders }

procedure TObjectEntityOrders.Cancel;
begin
  inherited;
  QueryOrders.Cancel;
end;

procedure TObjectEntityOrders.InitializeObject;
begin
  inherited;
  QueryOrders.ParamByName('OrderNo').AsInteger := Key;
  QueryOrders.Open;
end;

procedure TObjectEntityOrders.Save;
begin
  inherited;
  QueryOrders.Post;
end;

function TObjectEntityOrders.UpdatesPending: boolean;
begin
  Result := (QueryOrders.State in [dsInsert, dsEdit]);
end;

end.
